## yrmcds 1.0.3

=== Makefile ===
# Makefile for yrmcds
# Prerequisites: gcc 4.8+ or clang 3.3+

PREFIX = /usr/local
DEFAULT_CONFIG = $(PREFIX)/etc/yrmcds.conf

CACHELINE_SIZE := $(shell getconf LEVEL1_DCACHE_LINESIZE)
ifeq ($(CACHELINE_SIZE), 0)
	CACHELINE_SIZE = 32
endif

CC = gcc
CXX = g++
CPPFLAGS = -I. -DCACHELINE_SIZE=$(CACHELINE_SIZE)
CPPFLAGS += -DDEFAULT_CONFIG=$(DEFAULT_CONFIG) -DUSE_TCMALLOC
OPTFLAGS = -O2 #-flto
DEBUGFLAGS = -gdwarf-3 #-fsanitize=address
WARNFLAGS = -Wall -Wnon-virtual-dtor -Woverloaded-virtual
CPUFLAGS = #-march=core2 -mtune=corei7
CXXFLAGS = -std=gnu++11 $(OPTFLAGS) $(DEBUGFLAGS) $(shell getconf LFS_CFLAGS) $(WARNFLAGS) $(CPUFLAGS)
LDFLAGS = -L. $(shell getconf LFS_LDFLAGS)
LIBTCMALLOC = -ltcmalloc_minimal
LDLIBS = $(shell getconf LFS_LIBS) -lyrmcds $(LIBTCMALLOC) -lpthread
CLDOC = LD_LIBRARY_PATH=/usr/local/clang/lib cldoc

HEADERS = $(wildcard src/*.hpp cybozu/*.hpp)
SOURCES = $(wildcard src/*.cpp cybozu/*.cpp)
OBJECTS = $(patsubst %.cpp,%.o,$(SOURCES))

EXE = yrmcdsd
TESTS = $(patsubst %.cpp,%,$(wildcard test/*.cpp))
LIB = libyrmcds.a
LIB_OBJECTS = $(filter-out src/main.o,$(OBJECTS))
PACKAGES = build-essential libgoogle-perftools-dev python-pip

all: $(EXE)
lib: $(LIB)
tests: $(TESTS)

strip: $(EXE)
	nm -n $(EXE) | grep -v '\( [aNUw] \)\|\(__crc_\)\|\( \$$[adt]\)' > $(EXE).map
	strip $(EXE)

install: $(EXE)
	cp etc/upstart /etc/init/yrmcds.conf
	cp etc/logrotate /etc/logrotate.d/yrmcds
	cp etc/yrmcds.conf $(DEFAULT_CONFIG)
	cp $(EXE) $(PREFIX)/sbin/yrmcds
	install -o nobody -g nogroup -m 644 /dev/null /var/log/yrmcds.log

COPYING.hpp: COPYING
	echo -n 'static char COPYING[] = R"(' > $@
	cat $< >>$@
	echo ')";' >>$@
src/main.o: COPYING.hpp

$(OBJECTS): $(HEADERS)

$(LIB): $(LIB_OBJECTS)
	$(AR) rcus $@ $^

$(EXE): src/main.o $(LIB)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

test/%.exe: test/%.o $(LIB)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)

$(TESTS): $(LIB)
	@$(MAKE) -s $@.exe
	./$@.exe
	@echo

html:
	@clang++ -v 2>/dev/null || (echo "No clang++ in PATH." && false)
	rm -rf html
	$(CLDOC) generate $(CPPFLAGS) $(CXXFLAGS) -w -D__STRICT_ANSI__ -- --output html --merge docs $(HEADERS)

serve: html
	@cd html; python -m SimpleHTTPServer 8888 || true

clean:
	rm -f src/*.o cybozu/*.o test/*.o test/*.exe COPYING.hpp $(EXE) $(EXE).map $(LIB)

setup:
	sudo apt-get install -y --install-recommends $(PACKAGES)
	sudo pip install cldoc --upgrade

.PHONY: all strip lib tests install html serve clean setup $(TESTS)

=== debian/changelog ===
yrmcds (1.0.3-4) unstable; urgency=medium

  * Fixed unowned files after purge (policy 6.8, 10.8): /var/log/yrmcds.log
    (Closes: #736276)
    - debian/postrm:
      * Append removing rcX.d and systemd symlinks on removal.
        - But ignore the unowned directories should be controlled by systemd.
      * Append logfiles on purge.
    - Delete debian/postrm.
    - Change installing service init files with dh_installinit.
      * Rename init.d to yrmcds.init.
      * Rename upstart to yrmcds.upstart.
      * Rename yrmcds.systemd to yrmcds.service.
  * Change installing logrotate config file with dh_installlogrotate
    - Add debian/yrmcds.logrotate.
    - Delete debian/patches/Fixes-logrotate.patch.
  * Change installing example keepalived.conf with dh_installexamples
    - Add debian/yrmcds.examples
    - Delete install process from debian/rules.
  * Rename installing files in DEBIAN directory.
    - Append prefix "yrmcds." to postinst, postrm.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 24 Jan 2014 14:34:24 +0900

yrmcds (1.0.3-3) unstable; urgency=medium

  * Fixed FTBFS Dependency installability problem in ia64, sparc
    - debian/control: Build-Depends
      * Update g++ >= 4:4.8 [!ia64 !sparc]
      * Append g++-4.8 [ia64 sparc]

 -- Kouhei Maeda <mkouhei@palmtb.net>  Tue, 21 Jan 2014 11:27:16 +0900

yrmcds (1.0.3-2) unstable; urgency=medium

  * debian/control
    - Build-Depends: Update g++ >= 4:4.8.
      Because alignas() is supported g++ 4.8 over.
    - Architecture: Change "any" to "linux-any".
  * Fixed FTBFS: undefined reference to `atomic_*_8' (Closes: #735984)
    - debian/rules: Append "-latomic" to LDFLAGS
      in mips, mipsel, powerpc, powerpcspe, amd64, i386, armel, armhf, s390x.
    - Thanks Roland Stigge <stigge@antcom.de>.
  * Fixed FTBFS: unrecognized option '-std=gnu++11' (Closes: #735629)
    - debian/rules: override CC=gcc-4.7, CXX=g++-4.7 in sparc, ia64.
    - debian/patches: Append Override-CC-CXX.patch.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Mon, 20 Jan 2014 16:26:29 +0900

yrmcds (1.0.3-1) unstable; urgency=medium

  * New upstream release (Closes: #735627)
  * Fixed FTBFS on powerpc: unrecognized option '-std=gnu++11' (Closes: #735629)
    - debian/control: Append g++ (>= 4.7) to Build-Depends.
    - Thanks Aaron M. Ucko <ucko@debian.org>.
  * Fixed FTBFS related dependency of libgoogle-perftools-dev
    - Using only amd64, i386, armel, armhf, powerpc.
    - debian/control:
      * Append above architecures to Build-Depends.
      * Append libgoogle-perftools4 of above architecures to Depends.
    - debian/rules:
      * Append -DUSE_TCMALLOC to CPPFLAGS.
      * Add LIBTCMALLOC.
    - debian/patches: Append Change-dependency-of-libgoogle-perftools-dev.patch
  * debian/copyright: Change The MIT License to The Expat License
  * debian/patches:
    - Remove applied paches as followings merged in upstream.
      * 0001-Change-how-to-get-cacheline-size.patch 
      * 0003-Clear-x86-specific-CPUFLAGS.patch
    - Remove prefix "000?-" from patch name
      * 0002-Disable-yrmcds-s-DEBUGFLAGS.patch
      * 0004-Change-to-append-CXXFLAGS.patch
      * 0005-Change-to-append-LDFLAGS.patch
      * 0006-Change-DEFAULT_CONFIG.patch
      * 0007-Fixes-logrotate.patch

 -- Kouhei Maeda <mkouhei@palmtb.net>  Sat, 18 Jan 2014 10:21:47 +0900

yrmcds (1.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #732706)

 -- Kouhei Maeda <mkouhei@palmtb.net>  Sat, 11 Jan 2014 11:46:33 +0900

=== debian/control ===
Source: yrmcds
Section: web
Priority: optional
Maintainer: Kouhei Maeda <mkouhei@palmtb.net>
Build-Depends: debhelper (>= 8.0.0), libgmp-dev, libmpfr-dev, libmpc-dev, libgoogle-perftools-dev [amd64 i386 armel armhf powerpc], quilt, dh-systemd (>= 1.5), g++ (>= 4:4.8) [!ia64 !sparc], g++-4.8 [ia64 sparc]
Standards-Version: 3.9.5
Homepage: http://cybozu.github.io/yrmcds/

Package: yrmcds
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, logrotate, libgoogle-perftools4 [amd64 i386 armel armhf powerpc]
Recommends: keepalived
Description: memcached compatible KVS with master/slave replication
 yrmcds is a memory object caching system with master/slave replication and
 server-side locking. Since its protocol is perfectly compatible with that of
 memcached, yrmcds can be used as a drop-in replacement for memcached.
 .
 A companion client library libyrmcds and a PHP extension are also available.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING = 1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

CPPFLAGS=`dpkg-buildflags --get CPPFLAGS`
# Work Arround: libgoogle-perftools-dev by depends on some architecures
ifneq (,$(findstring $(DEB_HOST_ARCH),amd64 i386 armel armhf powerpc))
CPPFLAGS += -DUSE_TCMALLOC
LIBTCMALLOC = -ltcmalloc_minimal
endif
export CPPFLAGS
export LIBTCMALLOC

ifneq (,$(findstring $(DEB_HOST_ARCH),sparc ia64))
export CC = gcc-4.8
export CXX = g++-4.8
endif

LDFLAGS += -latomic
LDFLAGS += `dpkg-buildflags --get LDFLAGS`
export LDFLAGS


CFLAGS += $(CPPFLAGS)
ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -fPIC
endif
export CFLAGS

%:
	dh $@ --with quilt,systemd


override_dh_auto_build-indep:
	$(MAKE)

override_dh_auto_test:
	$(MAKE) tests

override_dh_auto_install:
	install -d $(CURDIR)/debian/yrmcds/etc
	install -m 0644 $(CURDIR)/etc/yrmcds.conf $(CURDIR)/debian/yrmcds/etc/yrmcds.conf
	sed -i 's/^user = nobody/user = yrmcds/g' $(CURDIR)/debian/yrmcds/etc/yrmcds.conf
	sed -i 's/^group = nogroup/group = yrmcds/g' $(CURDIR)/debian/yrmcds/etc/yrmcds.conf
	install -d $(CURDIR)/debian/yrmcds/usr/sbin
	install $(CURDIR)/yrmcdsd $(CURDIR)/debian/yrmcds/usr/sbin/yrmcdsd

## yrmcds 1.0.4

=== Makefile ===
--- 
+++ 
@@ -20,8 +20,8 @@
 CXXFLAGS = -std=gnu++11 $(OPTFLAGS) $(DEBUGFLAGS) $(shell getconf LFS_CFLAGS) $(WARNFLAGS) $(CPUFLAGS)
 LDFLAGS = -L. $(shell getconf LFS_LDFLAGS)
 LIBTCMALLOC = -ltcmalloc_minimal
-LDLIBS = $(shell getconf LFS_LIBS) -lyrmcds $(LIBTCMALLOC) -lpthread
-CLDOC = LD_LIBRARY_PATH=/usr/local/clang/lib cldoc
+LDLIBS = $(shell getconf LFS_LIBS) -lyrmcds $(LIBTCMALLOC) -latomic -lpthread
+CLDOC := LD_LIBRARY_PATH=$(shell llvm-config --libdir) cldoc
 
 HEADERS = $(wildcard src/*.hpp cybozu/*.hpp)
 SOURCES = $(wildcard src/*.cpp cybozu/*.cpp)
@@ -45,7 +45,7 @@
 	cp etc/upstart /etc/init/yrmcds.conf
 	cp etc/logrotate /etc/logrotate.d/yrmcds
 	cp etc/yrmcds.conf $(DEFAULT_CONFIG)
-	cp $(EXE) $(PREFIX)/sbin/yrmcds
+	cp $(EXE) $(PREFIX)/sbin/yrmcdsd
 	install -o nobody -g nogroup -m 644 /dev/null /var/log/yrmcds.log
 
 COPYING.hpp: COPYING

=== debian/changelog ===
yrmcds (1.0.4-6) unstable; urgency=medium

  * Applied patch that dropping AI_ADDRCONFIG to support IPv6 link-local
    address only
    - This turned out that this glibc behavior is a bug introduced by 
      glibc any/local-ipv6-lookup.diff
      https://bugs.launchpad.net/ubuntu/+source/glibc/+bug/374674
    - debian/patches
      Drop-AI_ADDRCONFIG-to-support-IPv6-link-local-address-only.patch
      Make-tcp_connect-work-in-IPv6-only-env.patch

 -- Kouhei Maeda <mkouhei@palmtb.net>  Tue, 26 Aug 2014 17:59:51 +0900

yrmcds (1.0.4-5) unstable; urgency=medium

  * Applied patch that adding support for IPv6 link local address.
    - debian/patches/Add-support-for-IPv6-link-local-address.patch

 -- Kouhei Maeda <mkouhei@palmtb.net>  Wed, 13 Aug 2014 10:42:06 +0900

yrmcds (1.0.4-4) unstable; urgency=medium

  * Migrated to unstable.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 08 Aug 2014 10:50:49 +0900

yrmcds (1.0.4-3) experimental; urgency=medium

  * Fixed non-standard gcc/g++ used for build (gcc-4.8) (Closes: #751333) 
    - debian/control
      * Removed [!ia64 sparc] from g++ >= 4:4.8, g++ == 4:4.8 [ia64 sparc]
        at Build-Depends.
    - debian/rules
      * Removed export CC, CXX for ia64 and sparc.
      * Removed --with quilt at dh command.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Thu, 07 Aug 2014 10:29:10 +0900

yrmcds (1.0.4-2) unstable; urgency=medium

  * debian/yrmcds.service
    - Append User, Group to Service section.
  * debian/yrmcds.upstart
    - Append setuid, setgid.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Tue, 15 Apr 2014 10:48:16 +0900

yrmcds (1.0.4-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - Build-Depends: Append llvm.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 07 Mar 2014 07:13:48 +0900

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: web
 Priority: optional
 Maintainer: Kouhei Maeda <mkouhei@palmtb.net>
-Build-Depends: debhelper (>= 8.0.0), libgmp-dev, libmpfr-dev, libmpc-dev, libgoogle-perftools-dev [amd64 i386 armel armhf powerpc], quilt, dh-systemd (>= 1.5), g++ (>= 4:4.8) [!ia64 !sparc], g++-4.8 [ia64 sparc]
+Build-Depends: debhelper (>= 8.0.0), libgmp-dev, libmpfr-dev, libmpc-dev, libgoogle-perftools-dev [amd64 i386 armel armhf powerpc], quilt, dh-systemd (>= 1.5), g++ (>= 4:4.8), llvm
 Standards-Version: 3.9.5
 Homepage: http://cybozu.github.io/yrmcds/

=== debian/rules ===
--- 
+++ 
@@ -19,11 +19,6 @@
 export CPPFLAGS
 export LIBTCMALLOC
 
-ifneq (,$(findstring $(DEB_HOST_ARCH),sparc ia64))
-export CC = gcc-4.8
-export CXX = g++-4.8
-endif
-
 LDFLAGS += -latomic
 LDFLAGS += `dpkg-buildflags --get LDFLAGS`
 export LDFLAGS
@@ -36,7 +31,7 @@
 export CFLAGS
 
 %:
-	dh $@ --with quilt,systemd
+	dh $@ --with systemd
 
 
 override_dh_auto_build-indep:

## yrmcds 1.1.4

=== Makefile ===
--- 
+++ 
@@ -11,20 +11,19 @@
 
 CC = gcc
 CXX = g++
-CPPFLAGS = -I. -DCACHELINE_SIZE=$(CACHELINE_SIZE)
-CPPFLAGS += -DDEFAULT_CONFIG=$(DEFAULT_CONFIG) -DUSE_TCMALLOC
+CPPFLAGS = -I. -DCACHELINE_SIZE=$(CACHELINE_SIZE) $(TCMALLOC_FLAGS)
+CPPFLAGS += -DDEFAULT_CONFIG=$(DEFAULT_CONFIG)
 OPTFLAGS = -O2 #-flto
 DEBUGFLAGS = -gdwarf-3 #-fsanitize=address
 WARNFLAGS = -Wall -Wnon-virtual-dtor -Woverloaded-virtual
 CPUFLAGS = #-march=core2 -mtune=corei7
 CXXFLAGS = -std=gnu++11 $(OPTFLAGS) $(DEBUGFLAGS) $(shell getconf LFS_CFLAGS) $(WARNFLAGS) $(CPUFLAGS)
 LDFLAGS = -L. $(shell getconf LFS_LDFLAGS)
-LIBTCMALLOC = -ltcmalloc_minimal
 LDLIBS = $(shell getconf LFS_LIBS) -lyrmcds $(LIBTCMALLOC) -latomic -lpthread
-CLDOC := LD_LIBRARY_PATH=$(shell llvm-config --libdir) cldoc
+CLDOC := LD_LIBRARY_PATH=$(shell llvm-config --libdir 2>/dev/null) cldoc
 
-HEADERS = $(wildcard src/*.hpp cybozu/*.hpp)
-SOURCES = $(wildcard src/*.cpp cybozu/*.cpp)
+HEADERS = $(wildcard src/*.hpp src/*/*.hpp cybozu/*.hpp)
+SOURCES = $(wildcard src/*.cpp src/*/*.cpp cybozu/*.cpp)
 OBJECTS = $(patsubst %.cpp,%.o,$(SOURCES))
 
 EXE = yrmcdsd
@@ -32,6 +31,18 @@
 LIB = libyrmcds.a
 LIB_OBJECTS = $(filter-out src/main.o,$(OBJECTS))
 PACKAGES = build-essential libgoogle-perftools-dev python-pip
+
+ifndef HEADER
+  ifeq ($(shell $(MAKE) HEADER=gperftools/tcmalloc.h test_env), ok)
+    TCMALLOC_FLAGS = -DUSE_TCMALLOC
+    LIBTCMALLOC = -ltcmalloc_minimal
+    export TCMALLOC_FLAGS LIBTCMALLOC
+  else ifeq ($(shell $(MAKE) HEADER=google/tcmalloc.h test_env), ok)
+    TCMALLOC_FLAGS = -DUSE_TCMALLOC -DTCMALLOC_IN_GOOGLE
+    LIBTCMALLOC = -ltcmalloc_minimal
+    export TCMALLOC_FLAGS LIBTCMALLOC
+  endif
+endif
 
 all: $(EXE)
 lib: $(LIB)
@@ -57,7 +68,7 @@
 $(OBJECTS): $(HEADERS)
 
 $(LIB): $(LIB_OBJECTS)
-	$(AR) rcus $@ $^
+	$(AR) rcs $@ $^
 
 $(EXE): src/main.o $(LIB)
 	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< $(LDLIBS)
@@ -79,10 +90,13 @@
 	@cd html; python -m SimpleHTTPServer 8888 || true
 
 clean:
-	rm -f src/*.o cybozu/*.o test/*.o test/*.exe COPYING.hpp $(EXE) $(EXE).map $(LIB)
+	rm -f src/*.o src/*/*.o cybozu/*.o test/*.o test/*.exe COPYING.hpp $(EXE) $(EXE).map $(LIB)
 
 setup:
 	sudo apt-get install -y --install-recommends $(PACKAGES)
 	sudo pip install cldoc --upgrade
 
-.PHONY: all strip lib tests install html serve clean setup $(TESTS)
+test_env:
+	@T=$$(mktemp --suffix=.cpp); echo "#include <$(HEADER)>" >$$T; if $(CXX) $(CPPFLAGS) -E $$T >/dev/null 2>&1; then echo "ok"; else echo "fail"; fi; rm -f $$T
+
+.PHONY: all strip lib tests install html serve clean setup test_env $(TESTS)

=== debian/changelog ===
yrmcds (1.1.4-2) unstable; urgency=medium

  * debian/patches
    - Re-applied Change-dependency-of-libgoogle-perftools-dev.patch.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Thu, 25 Jun 2015 05:41:21 +0900

yrmcds (1.1.4-1) unstable; urgency=medium

  * New upstream release
  * debian/patches
    - Updated Override-CC-CXX.patch.
    - Deleted Change-dependency-of-libgoogle-perftools-dev.patch.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Wed, 24 Jun 2015 16:38:29 +0900

yrmcds (1.1.3-5) unstable; urgency=medium

  * Uploading to unstable.
  * Changed making directory and chainging permission of /var/tmp/yrmcds
    - debian/yrmcds.service
      * Changed ExecStartPre option.
      * Appends PermissionsStartOnly option.
    - debian/yrmcds.upstart
      * Changed pre-start section.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Mon, 18 May 2015 09:15:03 +0900

yrmcds (1.1.3-4) experimental; urgency=medium

  * Fixed typo ExecStartPre of debian/yrmcds.service

 -- Kouhei Maeda <mkouhei@palmtb.net>  Tue, 31 Mar 2015 05:24:34 +0900

yrmcds (1.1.3-3) experimental; urgency=medium

  * Supported ppc64el of dependencies
    - debian/control
      Build-Depends: libgoogle-perftools-dev
      Depends: libgoogle-perftools4

 -- Kouhei Maeda <mkouhei@palmtb.net>  Wed, 25 Mar 2015 17:35:11 +0900

yrmcds (1.1.3-2) experimental; urgency=medium

  * Reverted Removing workaround related libtcmalloc
    - debian/paches
      * Appended Change-dependency-of-libgoogle-perftools-dev.patch
    - debian/rules
      * Appended workaround related libtcmalloc

 -- Kouhei Maeda <mkouhei@palmtb.net>  Wed, 25 Mar 2015 10:55:21 +0900

yrmcds (1.1.3-1) experimental; urgency=medium

  * New upstream release
  * debian/control
    - Depends: Appended arm64 to libgoogle-perftools4

 -- Kouhei Maeda <mkouhei@palmtb.net>  Mon, 23 Mar 2015 21:42:00 +0900

yrmcds (1.1.2+git~402c94c-2) experimental; urgency=medium

  * Fixed debian version

 -- Kouhei Maeda <mkouhei@palmtb.net>  Mon, 23 Mar 2015 10:28:52 +0900

yrmcds (1.1.2~git402c94c-1) experimental; urgency=medium

  * New upstream release
  * debian/paches
    - Removed patches related IPv6 link local address why the upstream had
      supported
      * Add-support-for-IPv6-link-local-address.patch,
      * Drop-AI_ADDRCONFIG-to-support-IPv6-link-local-address-only.patch
      * Make-tcp_connect-work-in-IPv6-only-env.patch
    - Removed patch related libtcmalloc why the upstream had changed detecting
      it automatically
      * Change-dependency-of-libgoogle-perftools-dev.patch
  * debian/rules
    - Removed workaround related libtcmalloc
  * debian/copyright
    - Fixed space-in-std-shortname-in-dep5-copyright the expat license
  * debian/control
    - Bumped version Standards-Version to 3.9.6
    - Build-Depends: Appends arm64 to libgoogle-perftools-dev

 -- Kouhei Maeda <mkouhei@palmtb.net>  Mon, 23 Mar 2015 10:01:27 +0900

## yrmcds 1.1.5

=== Makefile ===
--- 
+++ 
@@ -32,16 +32,15 @@
 LIB_OBJECTS = $(filter-out src/main.o,$(OBJECTS))
 PACKAGES = build-essential libgoogle-perftools-dev python-pip
 
-ifndef HEADER
-  ifeq ($(shell $(MAKE) HEADER=gperftools/tcmalloc.h test_env), ok)
+TCMALLOC_HEADER := $(shell sh ./detect_tcmalloc.sh $(CXX) $(CPPFLAGS))
+ifeq ($(TCMALLOC_HEADER), gperftools/tcmalloc.h)
     TCMALLOC_FLAGS = -DUSE_TCMALLOC
     LIBTCMALLOC = -ltcmalloc_minimal
     export TCMALLOC_FLAGS LIBTCMALLOC
-  else ifeq ($(shell $(MAKE) HEADER=google/tcmalloc.h test_env), ok)
+else ifeq ($(TCMALLOC_HEADER), google/tcmalloc.h)
     TCMALLOC_FLAGS = -DUSE_TCMALLOC -DTCMALLOC_IN_GOOGLE
     LIBTCMALLOC = -ltcmalloc_minimal
     export TCMALLOC_FLAGS LIBTCMALLOC
-  endif
 endif
 
 all: $(EXE)
@@ -96,7 +95,4 @@
 	sudo apt-get install -y --install-recommends $(PACKAGES)
 	sudo pip install cldoc --upgrade
 
-test_env:
-	@T=$$(mktemp --suffix=.cpp); echo "#include <$(HEADER)>" >$$T; if $(CXX) $(CPPFLAGS) -E $$T >/dev/null 2>&1; then echo "ok"; else echo "fail"; fi; rm -f $$T
-
 .PHONY: all strip lib tests install html serve clean setup test_env $(TESTS)

=== debian/changelog ===
yrmcds (1.1.5-1) unstable; urgency=medium

  * New upstream release

 -- Kouhei Maeda <mkouhei@palmtb.net>  Wed, 18 Nov 2015 08:54:37 +0900

=== debian/control ===
Source: yrmcds
Section: web
Priority: optional
Maintainer: Kouhei Maeda <mkouhei@palmtb.net>
Build-Depends: debhelper (>= 8.0.0),
               libgmp-dev,
               libmpfr-dev,
               libmpc-dev,
               libgoogle-perftools-dev [amd64 i386 armel armhf arm64 powerpc ppc64el],
               quilt,
               dh-systemd (>= 1.5),
               g++ (>= 4:4.8),
               llvm
Standards-Version: 3.9.6
Homepage: http://cybozu.github.io/yrmcds/

Package: yrmcds
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends},
         adduser,
         logrotate,
         libgoogle-perftools4 [amd64 i386 armel armhf arm64 powerpc ppc64el]
Recommends: keepalived
Description: memcached compatible KVS with master/slave replication
 yrmcds is a memory object caching system with master/slave replication and
 server-side locking. Since its protocol is perfectly compatible with that of
 memcached, yrmcds can be used as a drop-in replacement for memcached.
 .
 A companion client library libyrmcds and a PHP extension are also available.

=== debian/rules ===
--- 
+++ 
@@ -12,9 +12,14 @@
 
 CPPFLAGS=`dpkg-buildflags --get CPPFLAGS`
 # Work Arround: libgoogle-perftools-dev by depends on some architecures
-ifneq (,$(findstring $(DEB_HOST_ARCH),amd64 i386 armel armhf powerpc))
-CPPFLAGS += -DUSE_TCMALLOC
-LIBTCMALLOC = -ltcmalloc_minimal
+ifndef HEADER
+  ifeq ($(shell $(MAKE) HEADER=gperftools/tcmalloc.h test_env), ok)
+	CPPFLAGS += -DUSE_TCMALLOC
+	LIBTCMALLOC = -ltcmalloc_minimal
+  else ifeq ($(shell $(MAKE) HEADER=google/tcmalloc.h test_env), ok)
+	CPPFLAGS += -DUSE_TCMALLOC -DTCMALLOC_IN_GOOGLE
+	LIBTCMALLOC = -ltcmalloc_minimal
+  endif
 endif
 export CPPFLAGS
 export LIBTCMALLOC
@@ -22,7 +27,6 @@
 LDFLAGS += -latomic
 LDFLAGS += `dpkg-buildflags --get LDFLAGS`
 export LDFLAGS
-
 
 CFLAGS += $(CPPFLAGS)
 ifneq (,$(filter x-fpic,$(DEB_BUILD_OPTIONS)))
@@ -32,7 +36,6 @@
 
 %:
 	dh $@ --with systemd
-
 
 override_dh_auto_build-indep:
 	$(MAKE)
@@ -47,4 +50,3 @@
 	sed -i 's/^group = nogroup/group = yrmcds/g' $(CURDIR)/debian/yrmcds/etc/yrmcds.conf
 	install -d $(CURDIR)/debian/yrmcds/usr/sbin
 	install $(CURDIR)/yrmcdsd $(CURDIR)/debian/yrmcds/usr/sbin/yrmcdsd
-

## yrmcds 1.1.6

=== debian/changelog ===
yrmcds (1.1.6-1) unstable; urgency=medium

  * New upstream release
  * debian/yrmcdsd.8
    - Updates command line options.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 01 Jul 2016 23:49:30 +0900

yrmcds (1.1.5-3) unstable; urgency=medium

  * debian/rules
    - Fixes TCMALLOC_FLAGS related macros.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 01 Jul 2016 23:23:52 +0900

yrmcds (1.1.5-2) unstable; urgency=medium

  * debian/control
    - Standard-Version: Bump version to 3.9.8. 
  * debian/yrmcds.service
    - Appends Documentation key to Unit section.
  * Renames debian/yrmcdsd.1 to debian/yrmcdsd.8.
  * debian/manpages
    - Changes debian/yrmcdsd.1 to debian/yrmcdsd.8.
  * Closes: #810698
    - debian/yrmcds.postrm
      * remove /etc/init/yrmcds.override after purge.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 01 Jul 2016 15:27:49 +0900

## yrmcds 1.1.8

=== Makefile ===
--- 
+++ 
@@ -51,8 +51,17 @@
 	nm -n $(EXE) | grep -v '\( [aNUw] \)\|\(__crc_\)\|\( \$$[adt]\)' > $(EXE).map
 	strip $(EXE)
 
+ifeq ($(wildcard /run/systemd/system), /run/systemd/system)
+install-service:
+	cp etc/yrmcds.service /etc/systemd/system/yrmcds.service
+	systemctl daemon-reload
+else
+install-service:
+	cp etc/upstart /etc/init/yrmcds.conf
+endif
+
 install: $(EXE)
-	cp etc/upstart /etc/init/yrmcds.conf
+	$(MAKE) install-service
 	cp etc/logrotate /etc/logrotate.d/yrmcds
 	cp etc/yrmcds.conf $(DEFAULT_CONFIG)
 	cp $(EXE) $(PREFIX)/sbin/yrmcdsd
@@ -95,4 +104,4 @@
 	sudo apt-get install -y --install-recommends $(PACKAGES)
 	sudo pip install cldoc --upgrade
 
-.PHONY: all strip lib tests install html serve clean setup test_env $(TESTS)
+.PHONY: all strip lib tests install install-service html serve clean setup test_env $(TESTS)

=== debian/changelog ===
yrmcds (1.1.8-1.1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 17:04:25 +0100

yrmcds (1.1.8-1.1) unstable; urgency=medium

  * Non-maintainer upload. (acked by maintainer)
  * Fix build with gcc 7. (Closes: #853715)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Tue, 27 Feb 2018 17:20:24 +0900

yrmcds (1.1.8-1) unstable; urgency=medium

  * New upstream release

 -- Kouhei Maeda <mkouhei@palmtb.net>  Tue, 04 Oct 2016 08:29:32 +0900

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                dh-systemd (>= 1.5),
                g++ (>= 4:4.8),
                llvm
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://cybozu.github.io/yrmcds/
 
 Package: yrmcds

=== debian/rules ===
--- 
+++ 
@@ -12,14 +12,9 @@
 
 CPPFLAGS=`dpkg-buildflags --get CPPFLAGS`
 # Work Arround: libgoogle-perftools-dev by depends on some architecures
-ifndef HEADER
-  ifeq ($(shell $(MAKE) HEADER=gperftools/tcmalloc.h test_env), ok)
-	CPPFLAGS += -DUSE_TCMALLOC
-	LIBTCMALLOC = -ltcmalloc_minimal
-  else ifeq ($(shell $(MAKE) HEADER=google/tcmalloc.h test_env), ok)
-	CPPFLAGS += -DUSE_TCMALLOC -DTCMALLOC_IN_GOOGLE
-	LIBTCMALLOC = -ltcmalloc_minimal
-  endif
+ifneq (,$(findstring $(DEB_HOST_ARCH),i386 amd64 powerpc ppc64el arm64 armel armhf))
+CPPFLAGS += -DUSE_TCMALLOC
+LIBTCMALLOC = -ltcmalloc_minimal
 endif
 export CPPFLAGS
 export LIBTCMALLOC
@@ -50,3 +45,6 @@
 	sed -i 's/^group = nogroup/group = yrmcds/g' $(CURDIR)/debian/yrmcds/etc/yrmcds.conf
 	install -d $(CURDIR)/debian/yrmcds/usr/sbin
 	install $(CURDIR)/yrmcdsd $(CURDIR)/debian/yrmcds/usr/sbin/yrmcdsd
+
+override_dh_systemd_enable:
+	dh_systemd_enable --name=yrmcds

## yrmcds 1.1.9

=== Makefile ===
--- 
+++ 
@@ -22,12 +22,12 @@
 LDLIBS = $(shell getconf LFS_LIBS) -lyrmcds $(LIBTCMALLOC) -latomic -lpthread
 CLDOC := LD_LIBRARY_PATH=$(shell llvm-config --libdir 2>/dev/null) cldoc
 
-HEADERS = $(wildcard src/*.hpp src/*/*.hpp cybozu/*.hpp)
-SOURCES = $(wildcard src/*.cpp src/*/*.cpp cybozu/*.cpp)
+HEADERS = $(sort $(wildcard src/*.hpp src/*/*.hpp cybozu/*.hpp))
+SOURCES = $(sort $(wildcard src/*.cpp src/*/*.cpp cybozu/*.cpp))
 OBJECTS = $(patsubst %.cpp,%.o,$(SOURCES))
 
 EXE = yrmcdsd
-TESTS = $(patsubst %.cpp,%,$(wildcard test/*.cpp))
+TESTS = $(patsubst %.cpp,%,$(sort $(wildcard test/*.cpp)))
 LIB = libyrmcds.a
 LIB_OBJECTS = $(filter-out src/main.o,$(OBJECTS))
 PACKAGES = build-essential libgoogle-perftools-dev python-pip

=== debian/changelog ===
yrmcds (1.1.9-1) unstable; urgency=medium

  * New upstream release.
  * Removes debian/patches/fix_build_with_gcc7.patch.

 -- Kouhei Maeda <mkouhei@palmtb.net>  Sat, 22 Aug 2020 09:51:28 +0900

yrmcds (1.1.8-2) unstable; urgency=medium

  * debian/yrmcds.postinst
    - Fix adduser-with-home-var-run postinst.
  * debian/control
    - Bump version Standards-Version to 4.5.0
    - Build-Depends:
      * Bump version debhelper >= 9.20160709~.
      * Remove dh-systemd. (Closes: #958599)
      * Appends debhelper-compat (= 10).
  * debian/rules
    - Fixes debian-rules-uses-unnecessary-dh-argument dh ... --with=systemd.
  * Fixes spelling-error-in-patch-description.
    - debian/patches/Override-CC-CXX.patch
    - debian/patches/hange-dependency-of-libgoogle-perftools-dev.patch
  * Removes files.
    - debian/compat
    - debian/yrmcds.upstart
    - Fixes patch-file-present-but-not-mentioned-in-series
      * debian/patches/Drop-AI_ADDRCONFIG-to-support-IPv6-link-local-address-only.patch
      * debian/patches/Fixes-logrotate.patch
      * debian/patches/Make-tcp_connect-work-in-IPv6-only-env.patch
      * debian/patches/test-detect.patch
      * debian/patches/Change-to-append-CPPFLAGS.patch
      * debian/patches/Add-support-for-IPv6-link-local-address.patch

 -- Kouhei Maeda <mkouhei@palmtb.net>  Fri, 21 Aug 2020 23:54:27 +0900

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Section: web
 Priority: optional
 Maintainer: Kouhei Maeda <mkouhei@palmtb.net>
-Build-Depends: debhelper (>= 8.0.0),
+Build-Depends: debhelper (>=  9.20160709~),
+               debhelper-compat (= 10),
                libgmp-dev,
                libmpfr-dev,
                libmpc-dev,
                libgoogle-perftools-dev [amd64 i386 armel armhf arm64 powerpc ppc64el],
                quilt,
-               dh-systemd (>= 1.5),
                g++ (>= 4:4.8),
                llvm
-Standards-Version: 3.9.8
+Standards-Version: 4.5.0
 Homepage: http://cybozu.github.io/yrmcds/
 
 Package: yrmcds

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 export CFLAGS
 
 %:
-	dh $@ --with systemd
+	dh $@
 
 override_dh_auto_build-indep:
 	$(MAKE)
